#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>
#include <string.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) { \
            perror(userMsg);\
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define RD_END   (0)
#define WR_END   (1)
#define BUF_SIZE    (1024)

int main(int argc, char** argv) {
    
    //struct fd_pair cld2par = pipe();
    //struct fd_pair par2cld = pipe();

    int cld2par[2];
    checkError(pipe(cld2par) != -1, "pipe");
    int par2cld[2];
    checkError(pipe(par2cld) != -1, "pipe");

    pid_t childPid = fork();
    checkError(childPid != -1, "...");

    if (childPid != 0) {
        // parent
        close(cld2par[WR_END]);
        close(par2cld[RD_END]);

        char buffer[BUF_SIZE];
        sprintf(buffer, "%s", "neka poruka\n");

        checkError(write(par2cld[WR_END], buffer, strlen(buffer)) != -1, "write");

        int readBytes = read(cld2par[RD_END], buffer, BUF_SIZE-1);
        checkError(readBytes != -1, "read");

        buffer[readBytes] = 0;
        printf("child: %s\n", buffer);

        close(par2cld[WR_END]);
        close(cld2par[RD_END]);
    }
    else {

        // child
        close(cld2par[RD_END]);
        close(par2cld[WR_END]);

        char buffer[BUF_SIZE];
        int readBytes = read(par2cld[RD_END], buffer, BUF_SIZE-1);
        checkError(readBytes != -1, "read");

        buffer[readBytes] = 0;
       // printf("Message from parent: %s\n", buffer);
        strcat(buffer, " Child");

        checkError(write(cld2par[WR_END], buffer, strlen(buffer)) != -1, "write");

        close(par2cld[RD_END]);
        close(cld2par[WR_END]);

        exit(EXIT_SUCCESS);
    }

    checkError(wait(NULL) != -1, "wait");

    exit(EXIT_SUCCESS);
}