#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) { \
            perror(userMsg);\
            exit(EXIT_FAILURE); \
        } \
    } while (0)

int main(int argc, char** argv) {
    
    int x = 10;
    int y = 15;

    pid_t childPid = fork();
    checkError(childPid != -1, "fork");

    if (childPid == 0) {
        x += 50;
        y -= 50;
      
        printf("Child: x = %d, y = %d\n", x, y);

        exit(EXIT_SUCCESS);
    }

    // parent
    x -= 20;
    y += 50;

    checkError(wait(NULL) != -1, "wait");

    printf("Parent: x = %d, y = %d\n", x, y);

    exit(EXIT_SUCCESS);
}